searchNodes=[{"ref":"Mix.Tasks.Local.Nerves.html","title":"Mix.Tasks.Local.Nerves","type":"task","doc":"Check for updates to nerves_bootstrap Example: mix local.nerves This accepts the same command line options as archive.install."},{"ref":"Mix.Tasks.Nerves.Clean.html","title":"Mix.Tasks.Nerves.Clean","type":"task","doc":"Cleans dependencies and build artifacts Since this is a destructive action, cleaning of dependencies only occurs when one of the following are specified: dep1 dep2 - the names of Nerves dependencies to be cleaned, separated by spaces --all - cleans all Nerves dependencies"},{"ref":"Mix.Tasks.Nerves.New.html","title":"Mix.Tasks.Nerves.New","type":"task","doc":"Creates a new Nerves project mix nerves.new PATH [--module MODULE] [--app APP] [--target TARGET] [--cookie STRING] The project will be created at PATH. The application name and module name will be inferred from PATH unless --module or --app is given. An --app option can be given in order to name the OTP application for the project. A --module option can be given in order to name the modules in the generated code skeleton. A --target option can be given to limit support to one or more of the officially Nerves systems. A --cookie options can be given to set the Erlang distribution cookie in vm.args. This defaults to a randomly generated string. Generate a project without nerves_pack support by passing --no-nerves-pack. Examples mix nerves.new blinky Is equivalent to: mix nerves.new blinky --module Blinky Generate a project that only supports Raspberry Pi 3 mix nerves.new blinky --target rpi3 Generate a project that supports Raspberry Pi 3 and Raspberry Pi Zero mix nerves.new blinky --target rpi3 --target rpi0 Generate a project without nerves_pack mix nerves.new blinky --no-nerves-pack"},{"ref":"Mix.Tasks.Nerves.System.Shell.html","title":"Mix.Tasks.Nerves.System.Shell","type":"task","doc":"Open a shell in a system&#39;s build directory. In order to make the experience as similar as possible, we attach to a Docker container on non-Linux platforms and run a sub-shell on Linux. Examples Configure the system for the current project&#39;s target: mix nerves.system.shell"},{"ref":"Nerves.Bootstrap.Aliases.html","title":"Nerves.Bootstrap.Aliases","type":"module","doc":""},{"ref":"Nerves.Bootstrap.Aliases.html#add_aliases/1","title":"Nerves.Bootstrap.Aliases.add_aliases/1","type":"function","doc":""},{"ref":"Nerves.Bootstrap.Aliases.html#add_host_aliases/1","title":"Nerves.Bootstrap.Aliases.add_host_aliases/1","type":"function","doc":""},{"ref":"Nerves.Bootstrap.Aliases.html#add_target_aliases/1","title":"Nerves.Bootstrap.Aliases.add_target_aliases/1","type":"function","doc":""},{"ref":"Nerves.Bootstrap.Aliases.html#deps_update/1","title":"Nerves.Bootstrap.Aliases.deps_update/1","type":"function","doc":""},{"ref":"Nerves.Bootstrap.Aliases.html#host_config/1","title":"Nerves.Bootstrap.Aliases.host_config/1","type":"function","doc":""},{"ref":"Nerves.Bootstrap.Aliases.html#init/0","title":"Nerves.Bootstrap.Aliases.init/0","type":"function","doc":""},{"ref":"Nerves.Bootstrap.Aliases.html#run/1","title":"Nerves.Bootstrap.Aliases.run/1","type":"function","doc":""},{"ref":"Nerves.Bootstrap.Aliases.html#target_config/2","title":"Nerves.Bootstrap.Aliases.target_config/2","type":"function","doc":""},{"ref":"readme.html","title":"nerves_bootstrap","type":"extras","doc":"nerves_bootstrap nerves_bootstrap is an Elixir archive that supplies a new project generator and enhances mix to support downloading or building all of the non-Elixir things needed for Nerves-based projects. This includes crosscompilers, Linux kernels, C libraries and more. Most users should read the Nerves Installation Guide for installing and using Nerves. Read on for details specific to nerves_bootstrap."},{"ref":"readme.html#installation","title":"nerves_bootstrap - Installation","type":"extras","doc":"To install for the first time: mix archive.install hex nerves_bootstrap To update your nerves_bootstrap, you may either run the installation line above or: mix local.nerves If you need a specific version, run: mix archive.install hex nerves_bootstrap 1.0.1 Finally, if you want to install from source: git clone https://github.com/nerves-project/nerves_bootstrap.git cd nerves_bootstrap mix do deps.get, archive.build, archive.install"},{"ref":"readme.html#mix-integration","title":"nerves_bootstrap - Mix integration","type":"extras","doc":"By default, Nerves enhancements to mix are not included. This means that your non-Nerves projects will continue to build like they did before. Projects that use Nerves require additions to their mix.exs files. If you used mix nerves.new to create your project, you&#39;ll already have those additions. Nerves uses the aliases feature in mix. Ensure that the following code is in your mix.exs to pull in the integration: def project do [ # ... aliases: [loadconfig: [&amp;bootstrap/1]], ] end # Starting nerves_bootstrap pulls in the Nerves hooks to mix, but only # if the MIX_TARGET environment variable is set. defp bootstrap(args) do Application.start(:nerves_bootstrap) Mix.Task.run(&quot;loadconfig&quot;, args) end"},{"ref":"readme.html#mix-tasks","title":"nerves_bootstrap - Mix tasks","type":"extras","doc":"mix nerves.new A mix task for creating new Nerves projects. mix nerves.new my_new_nerves_project [options] The new project&#39;s mix.exs contains logic for building any of the supported hardware systems. The customary way of selecting the specific target is to export MIX_TARGET. Here&#39;s a common build script: export MIX_TARGET=rpi3 mix deps.get mix firmware mix firmware.burn If you look at the generated mix.exs, you&#39;ll see how MIX_TARGET is used. The generated project includes nerves_init_gadget. This simplifies the initial configuration for many target platforms by including support for networking, firmware updates, and helpful utilities. If you want a minimal project that does not include nerves_init_gadget, pass --no-init-gadget: mix nerves.new my_new_nerves_project --no-init-gadget To use nerves_pack instead of nerves_init_gadget you can pass --nerves-pack. See nerves_pack for more information. mix nerves.new my_new_nerves_project --nerves-pack mix local.nerves This task checks hex.pm for updates to the nerves_bootstrap archive. If one exists, you&#39;ll be prompted to update. mix nerves.clean This task cleans dependencies in a similar way to mix deps.clean, but it additionally erases downloaded artifacts and build products from Nerves packages. mix nerves.system.shell This task starts up a shell in an environment suitable for modifying Nerves systems. This allows you to interact with make menuconfig in Buildroot, manually enable and build C libraries, the Linux kernel, bootloaders, and more. Depending on your system, it may also start up Docker. See the Nerves documentation for usage."},{"ref":"readme.html#building-systems-and-toolchains","title":"nerves_bootstrap - Building systems and toolchains","type":"extras","doc":"Nerves expects systems and toolchains to include a URL to a precompiled build artifact. Building these dependences can take hours in some cases, so Nerves will not automatically compile them. It can do this, though, and depending on your computer, it may even start up Docker to do the builds. To force compilation to happen, add a :nerves option for the desired package in your top level project: {:nerves_system_rpi0, &quot;~&gt; 1.5&quot;, nerves: [compile: true]}"}]